<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>tools/rulebase.h Source File (CEL: Crystal Entity Layer 2.0 Public API Reference)</title>
<link href="tabs.css" rel="stylesheet" type="text/css">
<link href="doxygen.css" rel="stylesheet" type="text/css">
</head><body>
<table border="0" cellpadding="0" cellspacing="0" width="100%" class="head">
 <tr height="59">
  <td class="head" width="202" valign="bottom" style="padding-left:0;"><a href="http://cel.crystalspace3d.org/"><img src="celblur.png" width="210" height="59" alt="CEL" border="0"></a></td>
  <td class="head"><h2>Public API Reference</h2></td>
 </tr>
 <tr height="11">
  <td colspan="2" class="headshadow" valign="top" style="padding-left:0;"><img src="celshadow.png" width="9" height="11" alt="" border="0"></td>
 </tr>
</table>
<div class="content">
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">tools/rulebase.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    Crystal Space Entity Layer</span>
<a name="l00003"></a>00003 <span class="comment">    Copyright (C) 2006 by Jorrit Tyberghein</span>
<a name="l00004"></a>00004 <span class="comment">  </span>
<a name="l00005"></a>00005 <span class="comment">    This library is free software; you can redistribute it and/or</span>
<a name="l00006"></a>00006 <span class="comment">    modify it under the terms of the GNU Library General Public</span>
<a name="l00007"></a>00007 <span class="comment">    License as published by the Free Software Foundation; either</span>
<a name="l00008"></a>00008 <span class="comment">    version 2 of the License, or (at your option) any later version.</span>
<a name="l00009"></a>00009 <span class="comment">  </span>
<a name="l00010"></a>00010 <span class="comment">    This library is distributed in the hope that it will be useful,</span>
<a name="l00011"></a>00011 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00012"></a>00012 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00013"></a>00013 <span class="comment">    Library General Public License for more details.</span>
<a name="l00014"></a>00014 <span class="comment">  </span>
<a name="l00015"></a>00015 <span class="comment">    You should have received a copy of the GNU Library General Public</span>
<a name="l00016"></a>00016 <span class="comment">    License along with this library; if not, write to the Free</span>
<a name="l00017"></a>00017 <span class="comment">    Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.</span>
<a name="l00018"></a>00018 <span class="comment">*/</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#ifndef __CEL_RULEBASE__</span>
<a name="l00021"></a>00021 <span class="preprocessor"></span><span class="preprocessor">#define __CEL_RULEBASE__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/cstypes_8h.html">cstypes.h</a>&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/scf_8h.html">csutil/scf.h</a>&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/ref_8h.html">csutil/ref.h</a>&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/hash_8h.html">csutil/hash.h</a>&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/csstring_8h.html">csutil/csstring.h</a>&quot;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="keyword">struct </span><a class="code" href="structiCelExpression.html" title="Interface for a single expression.">iCelExpression</a>;
<a name="l00030"></a>00030 
<a name="l00034"></a><a class="code" href="structiCelRule.html">00034</a> <span class="keyword">struct </span><a class="code" href="structiCelRule.html" title="A rule.">iCelRule</a> : <span class="keyword">public</span> <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a>
<a name="l00035"></a>00035 {
<a name="l00036"></a>00036   SCF_INTERFACE (<a class="code" href="structiCelRule.html" title="A rule.">iCelRule</a>, 0, 0, 1);
<a name="l00037"></a>00037 
<a name="l00041"></a>00041   <span class="keyword">virtual</span> <span class="keyword">const</span> <span class="keywordtype">char</span>* <a class="code" href="structiCelRule.html#aa66c4b3fda26f7f113d4e593ff09d4bb" title="Get the name of this rule.">GetName</a> () <span class="keyword">const</span> = 0;
<a name="l00042"></a>00042 
<a name="l00046"></a>00046   <span class="keyword">virtual</span> <span class="keyword">const</span> <span class="keywordtype">char</span>* <a class="code" href="structiCelRule.html#abab54d909be26632c2409994c8633238" title="Get the name of the variable that this rule will influence.">GetVariable</a> () <span class="keyword">const</span> = 0;
<a name="l00047"></a>00047 
<a name="l00051"></a>00051   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelRule.html#ae606769d885545319a75bd563bc37c7d" title="Set the name of the variable that this rule will influence.">SetVariable</a> (<span class="keyword">const</span> <span class="keywordtype">char</span>* var) = 0 ;
<a name="l00052"></a>00052 
<a name="l00057"></a>00057   <span class="keyword">virtual</span> <span class="keywordtype">size_t</span> <a class="code" href="structiCelRule.html#ab019185de00d43d488fd3df14886c32a" title="Get the index of the local variable that will be used by the expression for the variable that this ru...">GetVariableIndex</a> () = 0;
<a name="l00058"></a>00058 
<a name="l00062"></a>00062   <span class="keyword">virtual</span> <a class="code" href="structiCelExpression.html" title="Interface for a single expression.">iCelExpression</a>* <a class="code" href="structiCelRule.html#a6310d16348e2341e0f4990efa3325f75" title="Get the expression corresponding with this rule.">GetExpression</a> () = 0;
<a name="l00063"></a>00063 
<a name="l00067"></a>00067   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelRule.html#a7833d49f741e627926e2d9cadf5fa5cf" title="Set the expression corresponding with this rule.">SetExpression</a> (<a class="code" href="structiCelExpression.html" title="Interface for a single expression.">iCelExpression</a>* expr) = 0;
<a name="l00068"></a>00068 
<a name="l00072"></a>00072   <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structCS_1_1StringID.html">csStringID</a> <a class="code" href="structiCelRule.html#ae28edbf087bbce17e7f9a388a1742cee" title="Get the priority ID for this rule.">GetPriority</a> () = 0;
<a name="l00073"></a>00073 
<a name="l00077"></a>00077   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelRule.html#a0e6c7226d6cc796a7131000be0b4ea6d" title="Set the priority ID for this rule.">SetPriority</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structCS_1_1StringID.html">csStringID</a> priority) = 0;
<a name="l00078"></a>00078 
<a name="l00082"></a>00082   <span class="keyword">virtual</span> <span class="keywordtype">size_t</span> <a class="code" href="structiCelRule.html#a5bfb94cca3565bf04c95e4d45be7dcfe" title="Get a priority number as defined by the rule base.">GetPriorityNumber</a> () <span class="keyword">const</span> = 0;
<a name="l00083"></a>00083 };
<a name="l00084"></a>00084 
<a name="l00086"></a>00086 <span class="keyword">typedef</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsHash.html">csHash&lt;csRef&lt;iCelRule&gt;</a>,<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsStringBase.html">csStringBase</a>&gt; <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsHash.html">celRuleHash</a>;
<a name="l00087"></a>00087 
<a name="l00091"></a><a class="code" href="structiCelRuleBase.html">00091</a> <span class="keyword">struct </span><a class="code" href="structiCelRuleBase.html" title="Interface for the Rule System.">iCelRuleBase</a> : <span class="keyword">public</span> <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a>
<a name="l00092"></a>00092 {
<a name="l00093"></a>00093   SCF_INTERFACE (<a class="code" href="structiCelRuleBase.html" title="Interface for the Rule System.">iCelRuleBase</a>, 0, 0, 1);
<a name="l00094"></a>00094 
<a name="l00098"></a>00098   <span class="keyword">virtual</span> <a class="code" href="structiCelRule.html" title="A rule.">iCelRule</a>* <a class="code" href="structiCelRuleBase.html#a5720b0fe3b5941787f54129b23758b5b" title="Create a new rule.">CreateRule</a> (<span class="keyword">const</span> <span class="keywordtype">char</span>* name) = 0;
<a name="l00099"></a>00099 
<a name="l00103"></a>00103   <span class="keyword">virtual</span> <a class="code" href="structiCelRule.html" title="A rule.">iCelRule</a>* <a class="code" href="structiCelRuleBase.html#afc66ea6e4d704b9cce80ba5340df8a87" title="Find a rule by name.">FindRule</a> (<span class="keyword">const</span> <span class="keywordtype">char</span>* name) = 0;
<a name="l00104"></a>00104 
<a name="l00108"></a>00108   <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsHash.html">celRuleHash</a>&amp; <a class="code" href="structiCelRuleBase.html#a23f67dd724a600f9454cf58f6c44c4d0" title="Iterate over the rules.">GetRules</a> () <span class="keyword">const</span> = 0;
<a name="l00109"></a>00109 
<a name="l00113"></a>00113   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelRuleBase.html#a73dcbd1292aa66a5e57108a2af5f6bda" title="Delete a rule.">DeleteRule</a> (<a class="code" href="structiCelRule.html" title="A rule.">iCelRule</a>* rule) = 0;
<a name="l00114"></a>00114 
<a name="l00118"></a>00118   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelRuleBase.html#a55649c68ef39f574916720d2f8fcbcd3" title="Clear priority table.">ClearPriorityTable</a> () = 0;
<a name="l00119"></a>00119 
<a name="l00125"></a>00125   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelRuleBase.html#a2a7197222fe2a57b3143eeb4732ef65d" title="Add a priority.">AddPriority</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structCS_1_1StringID.html">csStringID</a> priority) = 0;
<a name="l00126"></a>00126 };
<a name="l00127"></a>00127 
<a name="l00128"></a>00128 <span class="preprocessor">#endif // __CEL_RULEBASE__</span>
<a name="l00129"></a>00129 <span class="preprocessor"></span>
</pre></div></div><!-- contents -->
<hr size="1"><address><small>Generated for CEL: Crystal Entity Layer 2.0 by 
<a href="http://www.doxygen.org/index.html">doxygen</a> 1.7.6.1 
</small></address> </div></body> </html>
